from distutils.errors import DistutilsError
import os
import sys

from setuptools import Command


class BaseMigrationCommand(Command):

    user_options = [
                    ('package=', 'p', "the package containing the migration scripts"),
#                    ('verbose', 'v', "produce verbose output"),
                    ]
#    boolean_options = ['verbose']

    def initialize_options(self):
        self.package = None
        self.package_dir = None
        self.verbose = self.distribution.verbose

    def finalize_options(self):
        self.assert_package_defined()
        self.set_package_directory()
        self.assert_package_dir_defined()

    def assert_package_defined(self):
        if self.package is None:
            raise DistutilsError("You must defined a package")

    def set_package_directory(self):
        package_dir_map = self.distribution.package_dir
        guessed_dir = os.path.join(self.package.split('.'))
        if package_dir_map is None:
            package_dir = guessed_dir
        else:
            package_dir = package_dir_map.get('', guessed_dir)
        self.package_dir = package_dir
        
    def assert_package_dir_defined(self):
        if self.package_dir is None:
            raise DistutilsError("The package directory is not defined")


