from distutils.core import Distribution
from distutils.errors import DistutilsError

from nose.tools import assert_raises

from dbmigrate.command.make_migration import make_migration


def initialized_app():
    dist = Distribution()
    app = make_migration(dist)
    app.initialize_options()
    return app

def test_assert_package_defined():
    app = initialized_app()
    assert_raises(DistutilsError, app.assert_package_defined)
    app.package = "foo"
    app.assert_package_defined()

def test_assert_name_defined():
    app = initialized_app()
    assert_raises(DistutilsError, app.assert_name_defined)
    app.name = "foo"
    app.assert_name_defined()

def test_assert_package_dir_defined():
    app = initialized_app()
    assert_raises(DistutilsError, app.assert_package_dir_defined)
    app.package_dir = "foo"
    app.assert_package_dir_defined()

